#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char* argv[])
{
	const char* lock_file = "/tmp/xneur.pid";
	FILE* fpid = fopen(lock_file, "r");
	
	if (fpid != NULL)
	{
		fprintf(stderr, "%s: lock file '%s' exists, exiting.\n", 
				argv[0], lock_file);
		return 1;
	}
	fpid = fopen(lock_file, "w");
	if (!fpid)
	{
		fprintf(stderr, "%s: failed to create lock file.\n", argv[0]);
		return 1;
	}
	pid_t xn = fork();
	if (xn < 0)
	{
		fprintf(stderr, "%s: fork failed.\n", argv[0]);
		return 1;
	}
	if (xn == 0)
	{
		execlp("xneur", "xneur", NULL);
		fprintf(stderr, "%s: exec failed.\n", argv[0]);
		return 1;
	}
	fprintf(fpid, "%d", xn);
	fclose(fpid);
	return 0;
}
